VERSION 5.00
Begin VB.Form frmMain 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "VBC WIC Metadata"
   ClientHeight    =   855
   ClientLeft      =   45
   ClientTop       =   375
   ClientWidth     =   3450
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   57
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   230
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton Command1 
      Caption         =   "Command1"
      Height          =   615
      Left            =   90
      TabIndex        =   0
      Top             =   120
      Width           =   3195
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' Autor: F. Schler
' Datum: 08/2020

Option Explicit

Private pIWICImagingFactory As Long

Private Sub Form_Load()

    If CreateInterface(CLSID_WICImagingFactory1, IID_IWICImagingFactory, _
        pIWICImagingFactory) <> True Then
        
        Debug.Print "WICImagingFactory konnte nicht erstellt werden."
        
    End If
    
End Sub

Private Sub Form_Unload(Cancel As Integer)
    
    If pIWICImagingFactory <> 0& Then
    
        Call ReleaseInterface(pIWICImagingFactory)
    
    End If
    
End Sub

Private Sub Command1_Click()

    Call ReadMetadata(App.Path & "\RoteAugen.jpg") 'enthlt ein IFD Thumbnail
    'Call ReadMetadata(App.Path & "\test.jpg") ' enthlt ein paar andere Metadaten
    'Call ReadMetadata(App.Path & "\test.gif") ' Test Container-Level Metadata
    
End Sub

Private Sub ReadMetadata(ByVal sImage As String)

    Dim lFrameCount As Long
    Dim pStr(0) As Long
    Dim pIEnumString As Long
    Dim pIWICBitmapDecoder As Long
    Dim pIWICBitmapFrameDecode As Long
    Dim pIWICMetadataQueryReader As Long
    
    If pIWICImagingFactory <> 0& Then

        If Invoke(pIWICImagingFactory, CreateDecoderFromFilename, StrPtr(sImage), _
            0&, WICAccessOption.GENERIC_READ, WICDecodeOptions.WICDecodeMetadataCacheOnDemand, _
            VarPtr(pIWICBitmapDecoder)) = S_OK Then
            
            ' If an image format does not support container-level metadata, this will return
            ' WINCODEC_ERR_UNSUPPORTEDOPERATION. The only Windows provided image format that
            ' supports container-level metadata is GIF.
            If Invoke(pIWICBitmapDecoder, GetMetadataQueryReader_BD, _
                VarPtr(pIWICMetadataQueryReader)) = S_OK Then
            
                If Invoke(pIWICMetadataQueryReader, GetEnumerator, _
                    VarPtr(pIEnumString)) = S_OK Then

                    Do While Invoke(pIEnumString, Next_String, 1&, VarPtr(pStr(0)), 0&) = S_OK

                        Call EnumMetaData(pIWICMetadataQueryReader, Ptr2String(pStr(0)))

                        Debug.Print

                    Loop

                    Call ReleaseInterface(pIEnumString)

                End If

                Call ReleaseInterface(pIWICMetadataQueryReader)

            End If
            

            If Invoke(pIWICBitmapDecoder, GetFrameCount, VarPtr(lFrameCount)) = S_OK Then

                If lFrameCount > 0& Then

                    If Invoke(pIWICBitmapDecoder, GetFrame, 0&, _
                        VarPtr(pIWICBitmapFrameDecode)) = S_OK Then

                        If Invoke(pIWICBitmapFrameDecode, GetMetadataQueryReader_BFD, _
                            VarPtr(pIWICMetadataQueryReader)) = S_OK Then
                        
                            If Invoke(pIWICMetadataQueryReader, GetEnumerator, _
                                VarPtr(pIEnumString)) = S_OK Then
                            
                                Do While Invoke(pIEnumString, Next_String, 1&, VarPtr(pStr(0)), 0&) = S_OK
                                
                                    Call EnumMetaData(pIWICMetadataQueryReader, Ptr2String(pStr(0)))
                                    
                                    Debug.Print
                                
                                Loop
                            
                                Call ReleaseInterface(pIEnumString)
                                
                            End If
                            
                            Call ReleaseInterface(pIWICMetadataQueryReader)
                            
                        End If

                        Call ReleaseInterface(pIWICBitmapFrameDecode)

                    End If

                End If

            End If

            Call ReleaseInterface(pIWICBitmapDecoder)

        End If

    End If

End Sub

Private Sub EnumMetaData(ByVal pMetadataQueryReader As Long, ByVal sMetaData As String)

    Dim bData() As Byte
    Dim bValue(2047) As Byte
    Dim sTmp As String
    Dim pStr(0) As Long
    Dim lDataSize As Long
    Dim pIEnumString As Long
    Dim pIWICMetadataQueryReader As Long
    Dim tVARIANT As VARIANT_API
    Dim tPROPVARIANT As PROPVARIANT
    
    If pIWICImagingFactory <> 0& Then
    
        If Invoke(pMetadataQueryReader, GetMetadataByName, StrPtr(sMetaData), _
            VarPtr(tPROPVARIANT)) = S_OK Then
        
            If tPROPVARIANT.vt = VARENUM.VT_UNKNOWN Then
            
                Debug.Print sMetaData
            
                ' PROPVARIANT.vData = Pointer auf IUnknown
                If Invoke(tPROPVARIANT.vData, QueryInterface, VarPtr(Str2Guid(IID_IWICMetadataQueryReader)), _
                    VarPtr(pIWICMetadataQueryReader)) = S_OK Then
                    
                    Call PropVariantClear(tPROPVARIANT)
                
                    If Invoke(pIWICMetadataQueryReader, GetEnumerator, VarPtr(pIEnumString)) = S_OK Then
                            
                        Do While Invoke(pIEnumString, Next_String, 1&, VarPtr(pStr(0)), 0&) = S_OK
                        
                            Call EnumMetaData(pMetadataQueryReader, sMetaData & Ptr2String(pStr(0)))
                        
                        Loop
                        
                        Call ReleaseInterface(pIEnumString)
                        
                    End If
                
                    Call ReleaseInterface(pIWICMetadataQueryReader)
                    
                End If
            
            Else
                
                Select Case tPROPVARIANT.vt
                
                ' diese VT_-Werte sind mir bisher bei meinen Tests begegnet
                Case VARENUM.VT_I1, VARENUM.VT_I2, VARENUM.VT_I4, VARENUM.VT_I8, _
                     VARENUM.VT_UI1, VARENUM.VT_UI2, VARENUM.VT_UI4, VARENUM.VT_UI8, _
                     VARENUM.VT_R4, VARENUM.VT_R8, VARENUM.VT_LPSTR, VARENUM.VT_LPWSTR, _
                     VARENUM.VT_BOOL, VARENUM.VT_VECTOR Or VARENUM.VT_UI1, _
                     VARENUM.VT_VECTOR Or VARENUM.VT_UI2, VARENUM.VT_VECTOR Or VARENUM.VT_UI4, _
                     VARENUM.VT_VECTOR Or VARENUM.VT_UI8
            
                    If PropVariantToString(tPROPVARIANT, VarPtr(bValue(0)), UBound(bValue) + 1) = S_OK Then
                    
                        sTmp = CStr(bValue)
                
                        Debug.Print sMetaData & " = " & Mid$(sTmp, 1, InStr(1, sTmp, vbNullChar) - 1) & _
                            " (PROPVARIANT.vt = " & CStr(tPROPVARIANT.vt) & ")"
                
                    End If
                    
                Case VARENUM.VT_BLOB
                
                    If PropVariantToVariant(tPROPVARIANT, tVARIANT) = S_OK Then
                    
                        If tVARIANT.vt = VARENUM.VT_UNKNOWN Then
                    
                            ' tVARIANT.vData = Pointer auf IStream
                            If GetDataFromIStream(tVARIANT.vData, bData, lDataSize) = True Then
                                
                                ' Ausgabe des ByteArrays als String
                                Debug.Print sMetaData & " = " & StrConv(CStr(bData), vbUnicode) & _
                                    " (PROPVARIANT.vt = " & CStr(tPROPVARIANT.vt) & ")" & _
                                    " / (DataSize = " & CStr(lDataSize) & " Byte)"
                                
'                                ' Die RoteAugen.jpg enthlt ein IFD Thumbnail als JPEG!
'                                ' Daher simples Speichern des ByteArrays als JPG-Datei.
'                                If sMetaData = "/app1/{ushort=1}/{}" Then
'
'                                    If lDataSize > 0& Then
'
'                                        Open App.Path & "\Thumbnail.jpg" For Binary As #1
'
'                                        Put #1, , bData
'
'                                        Close #1
'
'                                    End If
'
'                                End If
                            
                            Else
                            
                                Debug.Print sMetaData & " = [Empty] (PROPVARIANT.vt = " & _
                                    CStr(tPROPVARIANT.vt) & ")" & _
                                    " / (DataSize = " & CStr(lDataSize) & " Byte)"
                                
                            End If
                    
                        End If
                    
                        Call VariantClear(tVARIANT)
                    
                    End If
                
                Case Else
                
                    ' Ausgabe falls noch ein VT_-Wert im Case VT_xxx fehlt
                    Debug.Print sMetaData & " = PROPVARIANT.VT = " & CStr(tPROPVARIANT.vt)
                
                End Select
                
            End If
        
            Call PropVariantClear(tPROPVARIANT)
        
        End If
        
    End If

End Sub

