Attribute VB_Name = "modWic"
' Autor: F. Schler
' Datum: 08/2020

Option Explicit

' ----==== Const ====----
Public Const S_OK As Long = &H0&
Private Const CLSCTX_INPROC As Long = &H1&
Private Const CC_STDCALL As Long = &H4&
Private Const IID_Release As Long = &H8&

Public Const CLSID_WICImagingFactory As String = "{cacaf262-9370-4615-a13b-9f5539da4c0a}"
Public Const CLSID_WICImagingFactory1 As String = CLSID_WICImagingFactory
Public Const CLSID_WICImagingFactory2 As String = "{317d06e8-5f24-433d-bdf7-79ce68d8abc2}"
Public Const IID_IWICImagingFactory As String = "{ec5ec8a9-c395-4314-9c77-54d7a935ff70}"
Public Const IID_IWICMetadataQueryReader As String = "{30989668-e1c9-4597-b395-458eedb808df}"

' ----==== Enums ====----
Public Enum vtb_Interfaces
    
    ' IUnknown
    QueryInterface = 0
    
    ' ISequentialStream
    Read_Stream = 3
    
    'IStream
    Seek_Stream = 5
    
    ' IWICImagingFactory
    CreateDecoderFromFilename = 3
    
    ' IWICBitmapDecoder
    GetFrameCount = 12
    GetFrame = 13
    GetMetadataQueryReader_BD = 8
    
    'IWICBitmapFrameDecode
    GetMetadataQueryReader_BFD = 8
    
    ' IWICMetadataQueryReader
    GetMetadataByName = 5
    GetEnumerator = 6
    
    ' IEnumString
    Next_String = 3

End Enum

' **************** sonstige Enums ****************
Public Enum VARENUM
    VT_EMPTY = 0  '&H0
    VT_NULL = 1  '&H1
    VT_I2 = 2  '&H2
    VT_I4 = 3  '&H3
    VT_R4 = 4  '&H4
    VT_R8 = 5  '&H5
    VT_CY = 6  '&H6
    VT_DATE = 7  '&H7
    VT_BSTR = 8  '&H8
    VT_DISPATCH = 9  '&H9
    VT_ERROR = 10  '&HA
    VT_BOOL = 11  '&HB
    VT_VARIANT = 12  '&HC
    VT_UNKNOWN = 13  '&HD
    VT_DECIMAL = 14  '&HE
    VT_I1 = 16  '&H10
    VT_UI1 = 17  '&H11
    VT_UI2 = 18  '&H12
    VT_UI4 = 19  '&H13
    VT_I8 = 20  '&H14
    VT_UI8 = 21  '&H15
    VT_INT = 22  '&H16
    VT_UINT = 23  '&H17
    VT_VOID = 24  '&H18
    VT_HRESULT = 25  '&H19
    VT_PTR = 26  '&H1A
    VT_SAFEARRAY = 27  '&H1B
    VT_CARRAY = 28  '&H1C
    VT_USERDEFINED = 29  '&H1D
    VT_LPSTR = 30  '&H1E
    VT_LPWSTR = 31  '&H1F
    VT_RECORD = 36  '&H24
    VT_FILETIME = 64  '&H40
    VT_BLOB = 65  '&H41
    VT_STREAM = 66  '&H42
    VT_STORAGE = 67  '&H43
    VT_STREAMED_OBJECT = 68  '&H44
    VT_STORED_OBJECT = 69  '&H45
    VT_BLOB_OBJECT = 70  '&H46
    VT_CF = 71  '&H47
    VT_CLSID = 72  '&H48
    VT_VECTOR = 4096  '&H1000
    VT_ARRAY = 8192  '&H2000
    VT_BYREF = 16384  '&H4000
    VT_RESERVED = 32768  '&H8000
    VT_ILLEGAL = 65535 '&HFFFF
    VT_ILLEGALMASKED = 4095 '&HFFF
    VT_TYPEMASK = 4095 '&HFFF
End Enum

Public Enum WICAccessOption
    GENERIC_READ = &H80000000
    GENERIC_WRITE = &H40000000
End Enum

Public Enum WICDecodeOptions
    WICDecodeMetadataCacheOnDemand = &H0&
    WICDecodeMetadataCacheOnLoad = &H1&
End Enum

Private Enum STREAM_SEEK
    STREAM_SEEK_SET = &H0&
    STREAM_SEEK_CUR = &H1&
    STREAM_SEEK_END = &H2&
End Enum

' ----==== Type ====----
Public Type GUID
    data1 As Long
    data2 As Integer
    data3 As Integer
    data4(0 To 7) As Byte
End Type

Public Type PROPVARIANT
    vt As Integer
    wReserved1 As Integer
    wReserved2 As Integer
    wReserved3 As Integer
    vData As Long
    Padding As Long
End Type

Public Type VARIANT_API
    vt As Integer
    wReserved1 As Integer
    wReserved2 As Integer
    wReserved3 As Integer
    vData As Long
    Padding As Long
End Type

' ----==== Kernel32 API-Deklarationen ====----
Private Declare Sub CopyMemory Lib "Kernel32.dll" _
                    Alias "RtlMoveMemory" ( _
                    ByRef pTo As Any, _
                    ByRef uFrom As Any, _
                    ByVal lSize As Long)

Private Declare Function lstrlenW Lib "Kernel32.dll" ( _
                         ByVal lpString As Long) As Long

' ----==== OleAut32 API-Deklarationen ====----
Private Declare Function DispCallFunc Lib "OleAut32.dll" ( _
                    ByVal pvInstance As Long, _
                    ByVal oVft As Long, _
                    ByVal cc As Long, _
                    ByVal vtReturn As VbVarType, _
                    ByVal cActuals As Long, _
                    ByVal prgvt As Any, _
                    ByVal prgpvarg As Any, _
                    ByRef pvargResult As Variant) As Long

Public Declare Function VariantClear Lib "OleAut32.dll" ( _
                        ByRef pVar As VARIANT_API) As Long

' ----==== Ole32 API-Deklarationen ====----
Private Declare Sub CoTaskMemFree Lib "Ole32.dll" ( _
                    ByVal hMem As Long)

Private Declare Function CLSIDFromString Lib "Ole32.dll" ( _
                         ByVal pstring As Long, _
                         ByRef pclsid As GUID) As Long

Private Declare Function CoCreateInstance Lib "Ole32.dll" ( _
                         ByVal rclsid As Long, _
                         ByVal pUnkOuter As Long, _
                         ByVal dwClsContext As Long, _
                         ByVal riid As Long, _
                         ByRef ppv As Long) As Long

Public Declare Function PropVariantClear Lib "Ole32.dll" ( _
                        ByRef pVar As PROPVARIANT) As Long

' ----==== Propsys API-Deklarationen ====----
Public Declare Function PropVariantToString Lib "propsys.dll" ( _
                        ByRef PropVar As PROPVARIANT, _
                        ByVal psz As Long, _
                        ByVal cch As Long) As Long

Public Declare Function PropVariantToVariant Lib "propsys.dll" ( _
                        ByRef pPropVar As PROPVARIANT, _
                        ByRef pVar As VARIANT_API) As Long

' ----==== Create Interface ====----
Public Function CreateInterface(ByVal sCLSID As String, _
    ByVal sIID As String, ByRef pInterface As Long) As Boolean

    ' Interface erstellen
    If CoCreateInstance(VarPtr(Str2Guid(sCLSID)), 0&, CLSCTX_INPROC, _
        VarPtr(Str2Guid(sIID)), pInterface) = S_OK Then

        CreateInterface = True

    End If

End Function

' ----==== Release Interface ====----
Public Sub ReleaseInterface(ByRef pInterface As Long)

    Dim vRet As Variant

    ' ist ein Pointer auf ein Interfac vorhanden
    If pInterface <> 0& Then

        ' Funktion Release des Interfaces aufrufen
        If DispCallFunc(pInterface, IID_Release, CC_STDCALL, vbLong, _
            0&, 0&, 0&, vRet) = S_OK Then

            pInterface = 0&

        End If

    End If

End Sub

' ----==== Call Interface Function ====----
Public Function Invoke(ByVal pInterface As Long, ByVal vtb As vtb_Interfaces, _
    ParamArray var()) As Variant
    
    If pInterface <> 0& Then
    
        Invoke = OleInvoke(pInterface, vtb, var)
        
    End If
    
End Function

Private Function OleInvoke(ByVal pInterface As Long, ByVal lCmd As Long, _
    ParamArray aParam()) As Variant
    
    Dim lCount As Long
    Dim lItem As Long
    Dim vRet As Variant
    Dim vParam As Variant
    Dim olePtr(10) As Long
    Dim oleTyp(10) As Integer

    ' ist ein Pointer auf ein Interface vorhanden
    If pInterface <> 0& Then

        ' nur wenn zum Aufruf der Interface-Funktion auch
        ' Parameter vorhanden sind.
        If UBound(aParam) >= 0 Then

            ' ParamArray nach Variant
            vParam = aParam

            ' ist der Variant ein Array
            If IsArray(vParam) Then vParam = vParam(0)

            ' Anzahl der Parameter
            lCount = UBound(vParam)

            ' alle Parameter durchlaufen
            For lItem = 0 To lCount

                ' Typ des Parameter
                oleTyp(lItem) = VarType(vParam(lItem))

                ' Pointer auf den Parameter
                olePtr(lItem) = VarPtr(vParam(lItem))

            Next

        End If

        ' Funktion des Interfaces aufrufen
        If DispCallFunc(pInterface, lCmd * 4, CC_STDCALL, vbLong, _
            lItem, VarPtr(oleTyp(0)), VarPtr(olePtr(0)), vRet) <> S_OK Then
            
            Debug.Print "Fehler beim Aufrufen der Interface-Funktion!"

        End If

    End If

    OleInvoke = vRet

End Function

' ----==== Helper Function ====----
Public Function Str2Guid(ByVal sStr As String) As GUID

    If Len(sStr) > 0& Then

        Call CLSIDFromString(StrPtr(sStr), Str2Guid)
    
    End If
    
End Function

Public Function Ptr2String(ByVal lpStrPointer As Long) As String

    Dim lLen As Long
    Dim bBuffer() As Byte

    lLen = lstrlenW(lpStrPointer) * 2 - 1

    If lLen > 0 Then

        ReDim bBuffer(lLen)

        Call CopyMemory(bBuffer(0), ByVal lpStrPointer, lLen)
        
        Call CoTaskMemFree(lpStrPointer)

        Ptr2String = bBuffer

    End If

End Function

Public Function GetDataFromIStream(ByVal pIStream As Long, ByRef bData() As Byte, _
    ByRef lDataSize As Long) As Boolean

    Dim bolRet As Boolean
    Dim curPosition As Currency

    bolRet = False
    
    If Invoke(pIStream, Seek_Stream, CCur(0), STREAM_SEEK.STREAM_SEEK_END, _
        VarPtr(curPosition)) = S_OK Then

        lDataSize = CLng(curPosition * 10000)
        
        If lDataSize > 0& Then

            ReDim bData(lDataSize - 1)

            If Invoke(pIStream, Seek_Stream, CCur(0), STREAM_SEEK.STREAM_SEEK_SET, _
                VarPtr(curPosition)) = S_OK Then

                If Invoke(pIStream, Read_Stream, VarPtr(bData(0)), lDataSize, _
                    VarPtr(curPosition)) = S_OK Then
                    
                    lDataSize = CLng(curPosition * 10000)
                    
                    bolRet = True

                End If

            End If
            
        End If

    End If

    GetDataFromIStream = bolRet

End Function
